#include "CRingBuffer.h"
#include <cstdlib>

CRingBuffer::CRingBuffer(int nSize)
{
	m_nSize = nSize;
	m_cntFilled = 0;
	m_pBuffer = (int*)malloc(nSize * sizeof(int));
	m_idxWrite = 0;
	m_idxRead = 0;
}

CRingBuffer::~CRingBuffer()
{
	free(m_pBuffer);
}

bool CRingBuffer::put(int nData)
{
	if(m_cntFilled < m_nSize) //es ist noch Platz zum schreiben vorhanden
	{
		*(m_pBuffer + m_idxWrite) = nData; //bergebenen Wert schreiben
		m_idxWrite = (m_idxWrite+1) % m_nSize; //Schreibindex erhhen, wenn gleich der Gre, wieder bei 0 anfangen
		m_cntFilled++; //Anzahl enthaltener Variablen erhhen
		return true;
	}
	return false; //es konnte nicht geschrieben werden (kein Platz)
}

bool CRingBuffer::get(int& nData)
{
	if(m_cntFilled > 0) //es sind Daten zum Lesen vorhanden
	{
		nData = *(m_pBuffer + m_idxRead); //nchsten Wert auslesen
		m_idxRead = (m_idxRead+1) % m_nSize; //Schreibindex erhhen, wenn gleich der Gre, wieder bei 0 anfangen
		m_cntFilled--; //Anzahl enthaltener Variablen erhhen
		return true; //Lesen erfolgreich
	}
	return false; //keine Daten zum Lesen
}
